/***************************************************************************
                          configview.cpp  -  description                              
                             -------------------                                         
    begin                : Sun Aug 22 1999                                           
    copyright            : (C) 1999 by ian geiser                         
    email                : geiseri@msoe.edu                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "configview.h"
#include <qslider.h>
configView::configView(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	QSlider_1->setTickmarks(QSlider::Below);
	connect(QPushButton_1, SIGNAL( pressed()), parent, SLOT( change()));
	connect(QPushButton_2, SIGNAL( pressed()), parent, SLOT( cancel()));
  connect(QSlider_1, SIGNAL( valueChanged( int)), SLOT( changeTimeout( int )));
}

configView::~configView(){
}
/** sets the config box's timout value */
void configView::setTimeout( int minutes){
	QSlider_1->setValue( minutes ); 	
}


/** This will set the station ID */
void configView::setStation( QString stationID ){
	QLineEdit_1->setText(stationID);
}

/** This will returnthe station ID. */
QString configView::getStationID(){
return QLineEdit_1->text();
}

/** This will return the station timeout. */
int configView::getTimeout(){
return timeout;
}


/** This wil change the timeout. */
void configView::changeTimeout( int newTimeout ){
	timeout = newTimeout;
}

bool configView::getUsa()
{
	return QCheckBox_1->isChecked();
}
void configView::setUsa( bool usa )
{
   QCheckBox_1->setChecked( usa );
}
bool configView::getOnline()
{
	return QCheckBox_2->isChecked();
}
void configView::setOnline( bool online )
{
   QCheckBox_2->setChecked( online );
}





