#ifndef KWEATHER_H
#define KWEATHER_H

#include <kapp.h>
#include <qwidget.h>
#include <qstring.h>
#include <kprocess.h>
#include <kfm.h>
#include <kremotefile.h>
#include <qtimer.h>
#include <qlabel.h>
#include "weather.h"
#include "weatherdisplay.h"
#include "configview.h"


class Kweather : public QWidget {
  Q_OBJECT 
public: 
  /** construtor */
  Kweather(QWidget*parent=0,const char* name=0);


  /** destructor */
  ~Kweather();
public slots:
	void processData();
  void loadFile();
  void helpFile();
	void exitApp();
  /** This will display a dilog with the current weather. */
  void report();
  void configure();
	void change();
	void cancel();
private: // Private attributes

	QString stationId;
	KFM *kfmConn;
	bool locked;
	QTimer *timeOut;
	int minutes;
	weatherDisplay *dispTemp;
	QString metarData;
	weather currentWeather;
	configView *cfgView;
	bool usa;
	bool offline;
	QString pid;
  /** This will load the config file and set up the application. */
	bool loadConf();
};
#endif


























