/***************************************************************************
                          weather.cpp  -  description                              
                             -------------------                                         
    begin                : Thu Aug 19 1999                                           
    copyright            : (C) 1999 by ian geiser                         
    email                : geiseri@msoe.edu                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "weather.h"
#include <qregexp.h>
#include <iostream.h>
weather::weather(){
 currentWeather = "";
 temprature = -100;
 dewpoint = -100;
}
weather::~weather(){
}

/** This will take in the new string and search it for new values. */
void weather::getNewData( QString newData){
  QList<QString> dataList;
  QString tempData;
  uint i = 0;
  newData.simplifyWhiteSpace();

  while( i < newData.length())
  {
  	if( (newData.at(i)) != ' ')
  		tempData += newData.at(i);
  	else
		{
			dataList.append( new QString(tempData) );
			//cout << tempData << endl;
			tempData = "";
		}
  	i++;
  }
	bool flag = false;
	for ( i =0; i < dataList.count(); i++)
	{
		if ( *dataList.at(i) == "RMK")
				flag = true;
		if ( !flag )
 		{
			parseWindSpeed(*dataList.at(i));
			parseVisability(*dataList.at(i));
			parseTemprature(*dataList.at(i));
			parseCurrent(*dataList.at(i));
			parseCover(*dataList.at(i));
			//cout << ":" << *dataList.at(i) << ":";
		}
		//cout << endl;
	}
}
/** Returns the windspeed as an int number. */
int weather::getWindSpeed(){
	return windSpeed;
}

/** Look for windspeed and modify the datastrucutre if needbe. */
int weather::parseWindSpeed(QString s){
	QRegExp regExp1 = QRegExp("00000KT", TRUE, FALSE);
	// Calm
	QRegExp regExp2 = QRegExp("[0-9][0-9][0-9][0-9][0-9]G[0-9][0-9]KT", TRUE, FALSE);
	// Wind with Gusts
	QRegExp regExp3 = QRegExp("[0-9][0-9][0-9][0-9][0-9]KT", TRUE, FALSE);
	// Steady Wind
	//QRegExp regExp4 = QRegExp("\d{3}V\d{3}", TRUE, FALSE);
	// Wind Direction


	if (s.contains( regExp1 ) == 1)
	{
		windSpeed = 0;
		gustSpeed = 0;
		windDir = 0;
	}
	else if ( s.contains( regExp2 ) == 1)
	{
		QString subStr = s.mid(6,2);
		gustSpeed = subStr.toInt();
		subStr = s.mid(0,3);
		windDir = subStr.toInt();
		subStr = s.mid(3,2);
		windSpeed = subStr.toInt();
	}
	else if ( s.contains( regExp3 ) == 1)
	{
		QString subStr = s.mid(3, 2);
   		windSpeed = subStr.toInt();
		subStr = s.mid(0,3);
		windDir = subStr.toInt();
		gustSpeed = 0;
	}
	else
	{
	    return(1);
	}
	
	return(0);	/* all went OK */
}

/** This will get the visability */
void weather::parseVisability( QString s){
	QRegExp regExp1 = QRegExp("[0-9][0-9]SM", TRUE, FALSE);
		QRegExp regExp2 = QRegExp("[0-9]SM", TRUE, FALSE);
	if (s.contains( regExp1 ) == 1)
	{
   	QString subStr = s.left(s.length() - 2);
   	visability = subStr.toInt();
	}
	else if ( s.contains( regExp2) == 1)
	{
   	QString subStr = s.left(s.length() - 2);
   	visability = subStr.toInt();
	}
}

/** This will return the gust speed. */
int weather::getGustSpeed(){
	return gustSpeed;
}

/** This will return the wind direction. */
QString weather::getWindDir(){
//    N       N	- 338-22  S - 157-202
// NW | NE    NE- 23-68   SW- 204-248
//W--`+'--E   E - 69-112  W - 249-294
// SW'|`SE    SE- 113-156 NW- 295-237
//    S
if (windDir && windDir<=360)
{
if ((windDir < 23) || ( windDir >= 338 ))
		return "N";
else if (windDir < 69)
		return "NE";
else if (windDir < 113)
		return "E";
else if (windDir < 157)
		return "SE";
else if (windDir < 203)
		return "S";
else if (windDir < 248)
		return "SW";
else if (windDir < 294)
		return "W";
else 
//if (windDir < 338)
		return "NW";
}
else
    return("??");

}



/** Will reutrn the visability in statute miles. */
int weather::getVisability(){
return visability;
}



/** This will get the temprature and the dew point. */
int weather::parseTemprature(QString s){
   QRegExp regExp1 = QRegExp("[0-9][0-9]/[0-9][0-9]", TRUE, FALSE);
   QRegExp regExp2 = QRegExp("[0-9][0-9]/M[0-9][0-9]", TRUE, FALSE);
   QRegExp regExp3 = QRegExp("M[0-9][0-9]/[0-9][0-9]", TRUE, FALSE);
   QRegExp regExp4 = QRegExp("M[0-9][0-9]/M[0-9][0-9]", TRUE, FALSE);

   if (s.contains( regExp1 ) == 1)
   {
      	QString subStr = s.mid(0,2);
      	temprature = subStr.toInt();
	subStr = s.mid(3,2);
	dewpoint = subStr.toInt();
	return(0);
   }
   else if (s.contains( regExp2 ) == 1)
   {
      	QString subStr = s.mid(0,2);
      	temprature = subStr.toInt();
	subStr = s.mid(4,2);
	dewpoint = -subStr.toInt();
	return(0);
   }
   else if (s.contains( regExp3 ) == 1)
   {
      	QString subStr = s.mid(1,2);
      	temprature = -subStr.toInt();
	subStr = s.mid(4,2);
	dewpoint = subStr.toInt();
	return(0);
   }
   else if (s.contains( regExp4 ) == 1)
   {
      	QString subStr = s.mid(1,2);
      	temprature = -subStr.toInt();
	subStr = s.mid(5,2);
	dewpoint = -subStr.toInt();
	return(0);
   }
    else
    {
	return(1);
    }
}

/** Returns the dew point in degrees Celsious */
int weather::getDewPoint(){
return dewpoint;
}

/** Returns the temprature */
int weather::getTemp(){
return temprature;
}


/** This will parse out the current cloud cover state. */
void weather::parseCover( QString s){
	QRegExp regExp1 = QRegExp("FEW[0-9][0-9][0-9]", TRUE, FALSE);	
	QRegExp regExp2 = QRegExp("SCT[0-9][0-9][0-9]", TRUE, FALSE);	
	QRegExp regExp3 = QRegExp("BKN[0-9][0-9][0-9]", TRUE, FALSE);	
	QRegExp regExp4 = QRegExp("OVC[0-9][0-9][0-9]", TRUE, FALSE);
	QRegExp regExp5 = QRegExp("SCK?CLR?", TRUE, FALSE);
   if (s.contains( regExp1 ) == 1)
   	skycondition = "Few	Clouds";
	 else if (s.contains( regExp2 ) == 1)
   	skycondition = "Scattered Clouds";
	 else if (s.contains( regExp3 ) == 1)
   	skycondition = "Broken Clouds";
	 else if (s.contains( regExp4 ) == 1)
   	skycondition = "Overcast Clouds";
	 else if (s.contains( regExp5 ) == 1)
   	skycondition = "Clear";	
}

/** This will return the current weather condition. */
void weather::parseCurrent(QString s){
  //cout << "Parseing: " << s << endl;
	bool good = false;
	QRegExp regExp1 = QRegExp("+[A-Z][A-Z][A-Z]?[A-Z]?", TRUE, FALSE);
	QRegExp regExp2 = QRegExp("-[A-Z][A-Z][A-Z]?[A-Z]?", TRUE, FALSE);
	QRegExp regExp3 = QRegExp("[A-Z][A-Z][A-Z]?[A-Z]?", TRUE, FALSE);
   if (s.contains( regExp2 ) == 1)
   {
			currentWeather = "Light";
			good = true;
   }
	else if (s.contains( regExp1 ) == 1)
	{
			currentWeather = "Heavy";
			good = true;
	}
  else if (s.contains( regExp3 ) == 1)
	{
			good = true;
  		currentWeather = "";
	}
	if ( s.contains( "MI" ) == 1 && good )
			currentWeather += " Shallow";	
	if ( s.contains( "PR" ) == 1 && good )
			currentWeather += " Partial";	
	if ( s.contains( "BC" ) == 1 && good )
			currentWeather += " Patches";	
	if ( s.contains( "DR" ) == 1 && good )
			currentWeather += " Low Drifting";	
	if ( s.contains( "BL" ) == 1 && good )
			currentWeather += " Blowing";	
	if ( s.contains( "SH" ) == 1 && good )
			currentWeather += " Showers";
	if ( s.contains( "TS" ) == 1 && good )
			currentWeather += " Thunder Storm";
	if ( s.contains( "FZ" ) == 1 && good )
			currentWeather += " Freezing";
	if ( s.contains( "DZ" ) == 1 && good )
			currentWeather += " Drizzle";
	if ( s.contains( "RA" ) == 1 && good )
			currentWeather += " Rain";
	if ( s.contains( "SN" ) == 1 && good )
			currentWeather += " Snow";
	if ( s.contains( "SG" ) == 1 && good )
			currentWeather += " Snow Grains";
	if ( s.contains( "IC" ) == 1 && good )
			currentWeather += " Ice Crystals";
	if ( s.contains( "PE" ) == 1 && good )
			currentWeather += " Ice Pellets";
	if ( s.contains( "GR" ) == 1 && good )
			currentWeather += " Hail";
	if ( s.contains( "GS" ) == 1 && good )
			currentWeather += " Small Hail Pellets";
	if ( s.contains( "UP" ) == 1 && good )
			currentWeather += " Unknown Precipitation";
	if ( s.contains( "BR" ) == 1 && good )
			currentWeather += " Mist";
	if ( s.contains( "FG" ) == 1 && good )
			currentWeather += " Fog";
	if ( s.contains( "FU" ) == 1 && good )
			currentWeather += " Smoke";
	if ( s.contains( "VA" ) == 1 && good )
			currentWeather += " Volcanic Ash";
	if ( s.contains( "DU" ) == 1 && good )
			currentWeather += " Widespread Dust";
	if ( s.contains( "SA" ) == 1 && good )
			currentWeather += " Sand";
	if ( s.contains( "HZ" ) == 1 && good )
			currentWeather += " Haze";
	if ( s.contains( "PY" ) == 1 && good )
			currentWeather += " Spray";
	if ( s.contains( "PO" ) == 1 && good )
			currentWeather += " Well Developed \n Dust Swirls";
	if ( s.contains( "SQ" ) == 1 && good )
			currentWeather += " Squall";
	if ( s.contains( "FC" ) == 1 && good )
			currentWeather += " Funnel Cloud";
	if ( s.contains( "SS" ) == 1 && good )
			currentWeather += " Sand Storm";
}

/** Reuturns the current weather. */
QString weather::getCurrentWeather(){
return currentWeather;
}

/** Returns the current cloud cover */
QString weather::getCover(){
return skycondition;
}

/** This will convert the number from C to F if the flag is true */
int weather::toUS( bool flag, int number){
if( flag )
	return ( number * 9 / 5) + 32;
else
	return number;
}
