/***************************************************************************
                          weather.h  -  description                              
                             -------------------                                         
    begin                : Thu Aug 19 1999                                           
    copyright            : (C) 1999 by ian geiser                         
    email                : geiseri@msoe.edu                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef WEATHER_H
#define WEATHER_H

#include <qstring.h>
#include <qlist.h>

/**This will get and fill the various datastructures that will hold the weather.
  *@author ian geiser
  */

class weather {
public: 
	weather();
  /** Returns the windspeed as an int number. */
  int getWindSpeed();
  /** This will take in the new string and search it for new values. */
  void getNewData( QString newData);
  /** This will return the gust speed. */
  int getGustSpeed();
  /** This will return the wind direction. */
  QString getWindDir();
  /** WIll reutrn the visability in statute miles. */
  int getVisability();
  /** Returns the temprature */
  int getTemp();
  /** Returns the dew point in degrees Celsious */
  int getDewPoint();
  /** Returns the current cloud cover */
  QString getCover();
  /** Reuturns the current weather. */
  QString getCurrentWeather();
  /** This will convert the number from C to F if the flag is true */
  static int toUS( bool flag, int number);
	~weather();
private:
  /** This is the current dew point. */
  int dewpoint;
  /** This is the air temprature in degrees ferenheight. */
  int temprature;
  /** Thisis the string value of the sky condition. */
  QString skycondition;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                private: // Private attributes
  /** This is the visability in miles. */
  int visability;
	/** This is the relitive humidity */
	int humidity;
	/** This is the pressure in Hg */
	int pressure;
  /** This is the wind direction **/
	int windDir;
	/** This is the wind speed **/
	int windSpeed;
	int gustSpeed;
	QString currentWeather;
  /** This is the station name that we are scanning **/

  // Private methods
  /** Look for windspeed and modify the datastrucutre if needbe. */
  /** This will get the visability */
  void parseVisability( QString s);
  /** This will get the temprature and the dew point. */
  int parseTemprature(QString s);
  /** This will return the current weather condition. */
  void parseCurrent(QString s);
  /** This will parse out the current cloud cover state. */
  void parseCover( QString s);
  int parseWindSpeed(QString s);
};

#endif


















